#if !defined(__MULTIBYTE_FUNC_HEADER__)
#define __MULTIBYTE_FUNC_HEADER__

// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// MultiByte Related Function
//   version: 0.0.0.2
//   description: this header was written to deal with multibyte char
//   author: hobbyscripter <hobbyscripter@gmail.com>
//   copyright: licensed under NSIS-license
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


// ===============
// Function Declare
// ===============
int isHighByteOfMultiByte(unsigned char ch);
int isHighByteOfMultiByteEx(unsigned int codepage, unsigned char ch);

// ===============
// Function Realization
// ===============
// ---------------
// Check if is the High Byte of MultiByte (Using System Codepage)
// ---------------
int
isHighByteOfMultiByte(unsigned char ch){
  int systemCodepage;

  systemCodepage = GetACP(); // Get System Codepage
  return isHighByteOfMultiByteEx(systemCodepage, ch);
}

// ---------------
// Check if is the High Byte of MultiByte
// ---------------
int
isHighByteOfMultiByteEx(unsigned int codepage,
                        unsigned char ch)
{
  if (codepage == 932 ||
      codepage == 936 ||
      codepage == 949 ||
      codepage == 950 ||
      codepage == 1361)
  {
    if (ch > 0x7F){
      return 1; // Is High Byte
    }
    else{
      return 0; // Is Not High Byte
    }
  }
  else{
    return 0; // Because these codepages are single byte, so just return 0.
  }
}


#endif // !defined(__MULTIBYTE_FUNC_HEADER__)
// EOF

